/*
** login.c for ftplib in /home/chary_c/Prog/my_ftp/client
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Fri Jan  4 12:22:17 2008 corentin chary
** Last update Fri Jan  4 12:57:54 2008 corentin chary
*/

#include <unistd.h>
#include <termios.h>
#include <errno.h>
#include <stdlib.h>

#include "error.h"
#include "gnl.h"
#include "ftplib.h"
#include "client.h"

static void	echo_off(struct termios *line)
{
  line->c_lflag &= ~ECHO;
  if (tcsetattr(0, TCSANOW, line) < 0)
    err(1, errno, "tcsetattr");
}

static void	echo_on(struct termios *line)
{
  line->c_lflag |= ECHO;
  if (tcsetattr(0, TCSANOW, line) < 0)
    err(1, errno, "tcsetattr");
}

int			login(t_ftp *ftp)
{
  char			*user;
  char			*pass;
  struct termios	line;
  int			ret;

  if (!isatty(STDIN_FILENO))
    err(1, 0, "stdin is not a tty");
  if (tcgetattr(0, &line) < 0)
    err(1, errno, "tcgetattr");
  user = readline(CLIENT_PROMPT_USER);
  echo_off(&line);
  pass = readline(CLIENT_PROMPT_PASS);
  echo_on(&line);
  putchar('\n');
  ret = ftp_login(ftp, user, pass);
  free(user);
  free(pass);
  return (ret);
}
