/*
** sock.h for sock in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Dec 31 12:01:12 2007 corentin chary
** Last update Sun Apr 13 19:30:21 2008 corentin chary
*/

#ifndef SOCK_H_
# define SOCK_H_

# include <sys/types.h>
# include <sys/socket.h>
# include <netinet/in.h>
# include <netdb.h>

typedef struct	s_sock_line
{
  char		*sl_buf;
  size_t	sl_len;
  size_t	sl_size;
  char		*sl_line;
  size_t	sl_lsize;
  size_t	sl_llen;
}		t_sock_line;

int	sock_connect(const char *host, unsigned short port);
int	sock_listen(short port);
int	sock_accept(int sockfd, struct sockaddr *addr,
		    socklen_t *addrlen, int timeout);
ssize_t	sock_send(int fd, const char *data, size_t bytes, int timeout);
ssize_t	sock_send_all(int fd, const char *data, size_t bytes, int timeout);
ssize_t	sock_recv(int fd, char *data, size_t bytes, int timeout);
ssize_t	sock_recv_all(int fd, char *data, size_t bytes, int timeout);
ssize_t	sock_recv_line(int fd, t_sock_line *buf, int timeout);
int	sock_pollfd(int fd, short event, int timeout);

#endif /* !SOCK_H_ */
