/*
** error.c for rush1 in /home/chary_c/Prog/rush
** 
** Made by corentin chary
** Login   <chary_c@epita.fr>
** 
** Started on  Sat Dec  1 08:37:48 2007 corentin chary
** Last update Sun Dec 30 19:10:46 2007 corentin chary
*/

#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "error.h"

static void	print_error(int errnum, const char *format, va_list ap)
{
  if (errnum)
    fprintf(stderr, "error: %s\n", strerror(errnum));
  vfprintf(stderr, format, ap);
  fprintf(stderr, "\n");
}

void	perr(int errnum, const char *format, ...)
{
  va_list	ap;

  va_start(ap, format);
  print_error(errnum, format, ap);
  va_end(ap);
}

void	err(int status, int errnum, const char *format, ...)
{
 va_list	ap;

  va_start(ap, format);
  print_error(errnum, format, ap);
  va_end(ap);
  exit(status);
}
