/*
** ftp_cmd.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Sun Dec 30 22:50:49 2007 corentin chary
** Last update Thu Apr 10 16:22:32 2008 corentin chary
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "strlcat.h"
#include "strlcpy.h"
#include "ftplib.h"
#include "ftplib_priv.h"
#include "error.h"
#include "sock.h"

int		ftp_cmd(t_ftp *ftp, const char *fmt, ...)
{
  char		buf[FTP_BUFSIZE];
  va_list	ap;
  size_t	bytes;
  int		ret;

  FTP_ASSERT(ftp);
  va_start(ap, fmt);
  bytes = vsnprintf(buf, sizeof (buf), fmt, ap);
  va_end(ap);
  bytes += sizeof("\r\n");
  if (bytes > FTP_BUFSIZE)
    return (-1);
  if (strpbrk(buf, "\r\n"))
    return (-1);
  printf(">> %s\n", buf);
  strlcat(buf, "\r\n", sizeof (buf));
  ret = sock_send_all(ftp->cmdfd, buf, bytes - 1, ftp->timeout);
  if (ret < 0)
    return (ret);
  return (ftp_recv_resp(ftp) < 0);
}
