/*
** ftp_connect.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Sun Dec 30 15:52:34 2007 corentin chary
** Last update Sun Apr 13 19:29:37 2008 corentin chary
*/

#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "sock.h"
#include "xalloc.h"
#include "error.h"
#include "ftplib.h"
#include "ftplib_priv.h"

static int	get_local_addr(int fd, struct sockaddr *addr)
{
  socklen_t	bytes;

  bytes = sizeof (*addr);
  memset(addr, 0, bytes);
  if (getsockname(fd, addr, &bytes) == 0)
    return (0);
  perr(errno, "getsockname()");
  return (-1);
}

t_ftp			*ftp_connect(const char *host, short port, int timeout)
{
  t_ftp			*ftp;
  int			fd;
  struct sockaddr	addr;

  fd = sock_connect(host, port);
  if (fd < 0)
    return (NULL);
  if (get_local_addr(fd, &addr))
    return (NULL);
  ftp = xcalloc(1, sizeof (*ftp));
  ftp->timeout = (timeout ? timeout : FTP_TIMEOUT);
  ftp->host = xstrdup(host);
  ftp->port = (port ? port : FTP_PORT);
  ftp->cmdfd = fd;
  memcpy(&ftp->addr, &addr, sizeof (addr));
  ftp_recv_resp(ftp);
  if (ftp->resp != 220)
    {
      close(fd);
      free(ftp);
      ftp = NULL;
    }
  return (ftp);
}
