/*
** ftp_get.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Wed Jan  2 16:26:33 2008 corentin chary
** Last update Sun Apr 13 19:41:32 2008 corentin chary
*/

#include <sys/types.h>
#include <unistd.h>
#include <errno.h>

#include "error.h"
#include "ftplib.h"
#include "ftplib_priv.h"

int	ftp_get(t_ftp *ftp, const char *path, int offset, int fd)
{
  FTP_ASSERT(ftp && path);
  if (lseek(fd, offset, SEEK_SET) < 0)
    {
      perr(errno, "lseek()");
      return (-1);
    }
  if (ftp_opendata(ftp))
    return (-1);
  ftp->data->local = fd;
  if (offset > 0)
    {
      if (ftp_cmd(ftp, "REST %u", offset) || ftp->resp != 350)
	goto fail;
    }
  if (ftp_cmd(ftp, "RETR %s", path) || (ftp->resp != 125 && ftp->resp != 150))
    goto fail;
  if (ftp_acceptdata(ftp))
    goto fail;
  return (0);
 fail:
  ftp_closedata(ftp);
  return (-1);
}
