/*
** ftp_mklist.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Fri Jan  4 09:57:15 2008 corentin chary
** Last update Thu Jan 10 07:46:29 2008 corentin chary
*/

#include <unistd.h>

#include "ftplib_priv.h"
#include "xalloc.h"

static char	**transfert_list(t_ftp *ftp)
{
  ssize_t	ret;
  size_t	bytes;
  int		pfd[2];
  char		**res;
  char		*str;

  str = NULL;
  res = NULL;
  bytes = 0;
  if (pipe(pfd))
    return (NULL);
  ftp->data->local = pfd[1];
  while ((ret = ftp_recv(ftp)) > 0)
    bytes += ret;
  if (ret < 0)
    goto exit;
  str = xcalloc(bytes + 1, 1);
  read(pfd[0], str, bytes);
  res = xstrsplit(str, "\r\n", NULL);
 exit:
  free(str);
  close(pfd[1]);
  close(pfd[0]);
  return (res);
}

char	**ftp_mklist(t_ftp *ftp, const char *cmd, const char *path)
{
  char	**ret;

  ret = NULL;
  if (!ftp || !cmd || !path)
    return (NULL);
  if (ftp_opendata(ftp))
    return (ret);
  if (ftp_cmd(ftp, cmd, path) ||
      (ftp->resp != 125 && ftp->resp != 150 && ftp->resp != 226))
    return (ret);
  if (ftp->resp == 226)
    {
      ftp_closedata(ftp);
      return (xbcalloc(1));
    }
  if (!ftp_acceptdata(ftp))
    ret = transfert_list(ftp);
  ftp_closedata(ftp);
  return (ret);
}
