/*
** ftp_port.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Wed Jan  2 15:09:03 2008 corentin chary
** Last update Sun Apr 13 19:29:25 2008 corentin chary
*/

#include <sys/socket.h>
#include <unistd.h>
#include <errno.h>

#include "error.h"
#include "ftplib.h"
#include "sock.h"
#include "xalloc.h"

static void	init_data(t_ftp *ftp, int fd)
{
  t_ftp_data	*data;

  data = xcalloc(1, sizeof (*data));
  data->type = FTP_TYPE_ACTV;
  data->fd = -1;
  data->local = -1;
  data->listen = fd;
  ftp_closedata(ftp);
  ftp->data = data;
}

int			ftp_port(t_ftp *ftp)
{
  int			fd;
  struct sockaddr_in	sin;
  socklen_t		bytes;
  char			ipbuf[FTP_IPBUF];

  FTP_ASSERT(ftp);
  fd = sock_listen(0);
  FTP_ASSERT(fd);
  bytes = sizeof (sin);
  if (getsockname(fd, (struct sockaddr *)&sin, &bytes) == -1)
    {
      perr(errno, "getsockname()");
      goto fail;
    }
  ftp_mkip(((struct sockaddr_in *) &ftp->addr)->sin_addr, sin.sin_port, ipbuf);
  if (ftp_cmd(ftp, "PORT %s", ipbuf) || ftp->resp != 200)
    goto fail;
  init_data(ftp, fd);
  return (0);
 fail:
  close(fd);
  return (-1);
}
