/*
** ftp_recv.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Thu Jan  3 12:17:48 2008 corentin chary
** Last update Fri Jan  4 15:11:49 2008 corentin chary
*/

#include <unistd.h>
#include <errno.h>

#include "ftplib.h"
#include "ftplib_priv.h"
#include "sock.h"
#include "error.h"

ssize_t		ftp_recv(t_ftp *ftp)
{
  ssize_t	ret;
  char		buf[FTP_BUFSIZE];

  FTP_ASSERT(ftp && ftp->data);
  ret = sock_recv(ftp->data->fd, buf, sizeof (buf), ftp->timeout);
  if (ret == 0)
    {
      ftp_closedata(ftp);
      if (ftp_recv_resp(ftp))
	return (-1);
      FTP_ASSERT(ftp->resp == 226 || ftp->resp == 250);
      return (0);
    }
  if (ret < 0)
    return (ret);
  ret = write(ftp->data->local, buf, ret);
  if (ret < 0)
    {
      ftp_closedata(ftp);
      perr(errno, "write");
    }
  return (ret);
}
