/*
** ftp_recv_resp.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Tue Jan  1 15:19:24 2008 corentin chary
** Last update Sun Apr 13 19:02:48 2008 corentin chary
*/

#include <string.h>
#include <ctype.h>
#include <poll.h>

#include "strlcat.h"
#include "strlcpy.h"
#include "ftplib.h"
#include "sock.h"

static int	is_valid_resp(const char *buf, size_t bytes)
{
  if (bytes < 4)
    return (0);
  if (isdigit(buf[0]) && isdigit(buf[1]) && isdigit(buf[2]))
    return (1);
  return (0);
}

int		ftp_recv_resp(t_ftp *ftp)
{
  char		bufline[FTP_BUFSIZE + 1];
  int		ret;
  t_sock_line	buf;

  bufline[FTP_BUFSIZE] = '\0';
  buf.sl_buf = ftp->inbuf;
  buf.sl_len = ftp->inbuf_len;
  buf.sl_size = FTP_BUFSIZE;
  buf.sl_line = bufline;
  buf.sl_lsize = FTP_BUFSIZE;
  while ((ret = sock_recv_line(ftp->cmdfd, &buf, ftp->timeout)))
    if (is_valid_resp(buf.sl_line, buf.sl_len))
      break;
  printf("<< %s\n", buf.sl_line);
  ftp->resp = (buf.sl_line[0] - '0') * 100;
  ftp->resp += (buf.sl_line[1] - '0') * 10;
  ftp->resp += (buf.sl_line[2] - '0') * 1;
  strlcpy(ftp->resptxt, bufline + 4, sizeof (ftp->resptxt));
  return (ret > 0 ? 0 : ret);
}

int		ftp_recv_all_resp(t_ftp *ftp)
{
  int		ret;

  ret = 0;
  while (sock_pollfd(ftp->cmdfd, POLLIN, 100) > 0)
    ret = ftp_recv_resp(ftp);
  return (ret);
}
