/*
** ftp_send.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Thu Jan  3 12:08:23 2008 corentin chary
** Last update Fri Jan  4 21:00:49 2008 corentin chary
*/

#include <unistd.h>
#include <errno.h>

#include "ftplib.h"
#include "ftplib_priv.h"
#include "sock.h"
#include "error.h"

ssize_t		ftp_send(t_ftp *ftp)
{
  ssize_t	ret;
  char		buf[FTP_BUFSIZE];

  FTP_ASSERT(ftp && ftp->data);
  ret = read(ftp->data->local, buf, sizeof (buf));
  if (ret == 0)
    {
      ftp_closedata(ftp);
      if (ftp_recv_resp(ftp))
	return (-1);
      FTP_ASSERT(ftp->resp == 226 || ftp->resp == 250);
      return (0);
    }
  if (ret < 0)
    {
      ftp_closedata(ftp);
      perr(errno, "read");
      return (ret);
    }
  ret = sock_send_all(ftp->data->fd, buf, ret, ftp->timeout);
  if (ret < 0)
    ftp_closedata(ftp);
  return (ret);
}
