/*
** strlcat.c for strlcat in /u/epitech_2010s/chary_c/cu/rendu/lib
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Tue Oct  9 14:26:26 2007 corentin chary
** Last update Thu Jan 10 07:32:45 2008 corentin chary
*/

#include <string.h>

#include "strlcat.h"

static size_t	_copy(char *p, const char *q, size_t bytes, size_t size)
{
  if (!q)
    return (bytes);
  while (*q)
    {
      if (bytes + 1 < size)
	*p = *q;
      p++;
      q++;
      bytes++;
    }
  *p = '\0';
  return (bytes);
}

size_t		strlcat(char *dst, const char *src, size_t size)
{
  char		*p;
  const char	*q;
  size_t	bytes;

  p = dst;
  q = src;
  bytes = 0;
  while (bytes < size && *p)
    {
      bytes++;
      p++;
    }
  if (bytes == size)
    return (bytes + strlen(src));
  bytes = _copy(p, q, bytes, size);
  return (bytes);
}
