/*
** gnl.c for minishell in /home/chary_c/Prog/minishell
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Fri Nov  9 10:49:03 2007 corentin chary
** Last update Sat Jan  5 13:53:41 2008 corentin chary
*/

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "xalloc.h"
#include "gnl.h"

static t_gnl_buf	stdin_gnl = {read, "", 0, 0, STDIN_FILENO};

static int      copy_buf(char **pline, t_gnl_buf *buf, int readed)
{
  int           i;
  char          *line;

  if (!buf->size)
    return (0);
  i = 0;
  *pline = xrealloc(*pline, readed + buf->size + 1);
  line = *pline + readed;
  while (i < buf->size)
    {
      line[i] = buf->buf[buf->start + i];
      if (line[i] == '\n')
        {
          line[i] = '\0';
          buf->start = (buf->start + i + 1) % buf->size;
          buf->size = (buf->start ? buf->size - i - 1 : 0);
          return (1);
        }
      i++;
    }
  buf->start = 0;
  buf->size = 0;
  return (0);
}

static int      check_old_buf(char **pline, t_gnl_buf *buf, size_t *readed)
{
  int           tmp;

  tmp = buf->size;
  if (tmp)
    {
      if (copy_buf(pline, buf, *readed))
          return (1);
      *readed = tmp;
    }
  return (0);
}

char	*gnl(t_gnl_buf *buf)
{
  ssize_t       ret;
  size_t        readed;
  char          *line;

  line = NULL;
  readed = 0;
  if (check_old_buf(&line, buf, &readed))
    return (line);
  while ((ret = buf->read(buf->fd, buf->buf, GNL_BUFFER_SIZE)) > 0)
    {
      buf->size = ret;
      if (copy_buf(&line, buf, readed))
        return (line);
      readed += ret;
    }
  if (!ret && !readed)
    {
      free(line);
      return (NULL);
    }
  line[readed] = '\0';
  return (line);
}

char	*readline(const char *prompt)
{
  printf("%s", prompt);
  fflush(stdout);
  return (gnl(&stdin_gnl));
}
