/*
** sock_connect.c for sock in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Dec 31 12:04:35 2007 corentin chary
** Last update Sun Apr 13 19:30:48 2008 corentin chary
*/

#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netdb.h>
#include <resolv.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#include "sock.h"
#include "error.h"

int			sock_connect(const char *host, unsigned short port)
{
  struct sockaddr_in	server;
  struct hostent	*hp;
  int			fd;

  fd = socket(AF_INET, SOCK_STREAM, 0);
  if (fd < 0)
    {
      perr(errno, "socket()");
      return (fd);
    }
  hp = gethostbyname(host);
  if (!hp)
    {
      perr(errno, "hostname %s is unknown", host);
      return (-1);
    }
  memcpy(&server.sin_addr, hp->h_addr, hp->h_length);
  server.sin_port = htons(port);
  server.sin_family = AF_INET;
  if (connect(fd, (struct sockaddr *)&server, sizeof (server)) < 0)
    {
      perr(errno, "can't connect to %s", host);
      return (-1);
    }
  return (fd);
}
