/*
** sock_listen.c for sock in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Wed Jan  2 14:50:17 2008 corentin chary
** Last update Sun Apr 13 19:31:48 2008 corentin chary
*/

#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <resolv.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#include "sock.h"
#include "error.h"

int	sock_listen(short port)
{
  struct sockaddr_in	sin;
  int			fd;
  int			one;

  fd = socket(AF_INET, SOCK_STREAM, 0);
  one = 1;
  if (fd < 0)
    {
      perr(errno, "socket()");
      return (fd);
    }
  if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR,
		 &one, sizeof (one)) == -1)
    {
      perr(errno, "setsockopt");
      return (-1);
    }
  sin.sin_family = AF_INET;
  sin.sin_port = htons(port);
  sin.sin_addr.s_addr = htonl(INADDR_ANY);
  if (bind(fd, (struct sockaddr *)&sin, sizeof (sin)) == -1)
    {
      perr(errno, "bind()");
      return (-1);
    }
  if (listen(fd, 2) == -1)
    {
      perr(errno, "listen()");
      return (-1);
    }
  return (fd);
}
