/*
** sock_recv.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Dec 31 11:52:38 2007 corentin chary
** Last update Thu Jan  3 12:51:33 2008 corentin chary
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <poll.h>
#include <errno.h>

#include "error.h"
#include "sock.h"

/* FIXME timeout correct */
ssize_t		sock_recv_all(int fd, char *data,
			      size_t bytes, int timeout)
{
  ssize_t	ret;
  size_t	recvd;

  recvd = 0;
  while (recvd < bytes)
    {
      ret = sock_recv(fd, data + recvd, bytes - recvd, timeout);
      if (ret < 0)
	return (ret);
      recvd += ret;
    }
  return (recvd);
}

ssize_t		sock_recv(int fd, char *data, size_t bytes, int timeout)
{
  ssize_t	ret;

  ret = sock_pollfd(fd, POLLIN, timeout);
  if (ret >= 0)
    ret = recv(fd, data, bytes, 0);
  if (ret < 0)
    {
      perr(errno, "recv()");
      return (ret);
    }
  return (ret);
}
