/*
** sock_recv_line.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Dec 31 17:58:26 2007 corentin chary
** Last update Tue Jan  1 14:47:21 2008 corentin chary
*/

#include <string.h>
#include <stdio.h>

#include "sock.h"

static void	makeline(t_sock_line *buf, char *p)
{
  ssize_t	size;

  *p = '\0';
  strncpy(buf->sl_line, buf->sl_buf, buf->sl_lsize);
  buf->sl_llen = p - buf->sl_buf;
  size = buf->sl_len - (buf->sl_llen + 2);
  if (size > 0)
    memmove(buf->sl_buf, p + 2, size);

}

ssize_t		sock_recv_line(int fd, t_sock_line *buf, int timeout)
{
  size_t	bytes;
  ssize_t	ret;
  char		*p;

  bytes = 0;
  while (bytes < buf->sl_lsize)
    {
      p = strstr(buf->sl_buf, "\r\n");
      if (p)
	{
	  makeline(buf, p);
	  break ;
	}
      ret = sock_recv(fd, buf->sl_buf + buf->sl_len, buf->sl_size, timeout);
      if (ret < 0)
	return (ret);
      buf->sl_len += ret;
      bytes += ret;
    }
  return (bytes);
}
