/*
** sock_send.c for ftplib in /home/chary_c/Prog/my_ftp/libftp
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Dec 31 11:52:38 2007 corentin chary
** Last update Thu Jan  3 12:51:55 2008 corentin chary
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <errno.h>
#include <poll.h>

#include "error.h"
#include "sock.h"

/* FIXME timeout */
ssize_t		sock_send_all(int fd, const char *data,
			      size_t bytes, int timeout)
{
  ssize_t	ret;
  size_t	sent;

  sent = 0;
  while (sent < bytes)
    {
      ret = sock_send(fd, data + sent, bytes - sent, timeout);
      if (ret < 0)
	return (ret);
      sent += ret;
    }
  return (sent);
}

ssize_t		sock_send(int fd, const char *data, size_t bytes, int timeout)
{
  ssize_t	ret;

  ret = sock_pollfd(fd, POLLOUT, timeout);
  if (ret >= 0)
    ret = send(fd, data, bytes, 0);
  if (ret < 0)
    {
      perr(errno, "send()");
      return (ret);
    }
  return (ret);
}
