/*
** child.c for ftpserver in /home/chary_c/Prog/my_ftp/server
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Jan  7 13:59:09 2008 corentin chary
** Last update Sun Apr 13 19:37:52 2008 corentin chary
*/

#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#include "server.h"
#include "cmds.h"

static void	motd(t_ftp *ftp)
{
  T(ftp, "New connection from %s\n",
    inet_ntoa(((struct sockaddr_in *)&ftp->addr)->sin_addr));
  resp(ftp, 220, "Welcome to my experimental ftp server");
}

static void	bye(t_ftp *ftp)
{
  TS(ftp, "Disconnect");
  resp(ftp, 221, "Goodbye");
  free(ftp->user);
  free(ftp->data);
  free(ftp->rnfr);
  close(ftp->fd);
}

static void	loop(t_ftp *ftp)
{
  t_cmd		cmd;

  cmd.cm_ftp = ftp;
  while (ftp->state != FTP_STATE_QUIT && readcmd(&cmd))
    {
      execcmd(&cmd);
      freecmd(&cmd);
    }
}

int	child(t_ftp *ftp)
{
  ftp->gnlbuf.fd = ftp->fd;
  motd(ftp);
  loop(ftp);
  bye(ftp);
  return (0);
}
