/*
** cmd_nlst.c for ftpserver in /home/chary_c/Prog/my_ftp/server
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Tue Jan  8 08:37:01 2008 corentin chary
** Last update Sun Apr 13 20:18:32 2008 corentin chary
*/

#include <unistd.h>
#include <errno.h>
#include <dirent.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>

#include "sock.h"
#include "error.h"
#include "server.h"
#include "cmds.h"

static int	loop(t_ftp *ftp, DIR *dip)
{
  char		buf[NAME_MAX];
  size_t	bytes;
  struct dirent	*dit;

  while ((dit = readdir(dip)) != NULL)
    {
      if (!strcmp(dit->d_name, ".") || !strcmp(dit->d_name, ".."))
	continue ;
      bytes = snprintf(buf, sizeof(buf), "%s\r\n", dit->d_name);
      if (sock_send_all(ftp->data->fd, buf, bytes, ftp->timeout) < 0)
	return (-1);
    }
  sock_send_all(ftp->data->fd, "\r\n", 2, ftp->timeout);
  return (0);
}

int		cmd_nlst(t_cmd *cmd)
{
  t_ftp		*ftp;
  char		*dir;
  DIR		*dip;
  int		ret;

  ret = 0;
  ftp = cmd->cm_ftp;
  dip = NULL;
  dir = (cmd->cm_argc == 2  && *cmd->cm_argv[1] != '-'? cmd->cm_argv[1] : ".");
  ret = resp(ftp, 150, "Here comes the directory listing.");
  if (check_dir(ftp, dir) || (dip = opendir(dir)) == NULL)
    {
      resp(ftp, 226, "Transfer done (but failed to open directory)");
      perr(errno, "opendir(%s)", dir);
      ret = -1;
    }
  else
    {
      ret = loop(ftp, dip);
      resp(ftp, 226, "Directory send OK.");
    }
  close_data(ftp);
  closedir(dip);
  return (ret);
}
