/*
** cmd_port.c for ftpserver in /home/chary_c/Prog/my_ftp/server
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Jan  7 21:17:31 2008 corentin chary
** Last update Sun Apr 13 20:11:12 2008 corentin chary
*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#include "server.h"
#include "cmds.h"
#include "sock.h"
#include "xalloc.h"

static int	read_port_port(const char *str, unsigned *port)
{
  char		*p;

  if (*str)
    *port = strtol(str, &p, 10);
  else
    return (-1);
  if (*p)
    *port = (*port << 8) | strtol(p + 1, NULL, 10);
  else
    return (-1);
  return (0);
}

static int	read_port(const char *str, char *buf,
			  size_t buflen, unsigned *port)
{
  size_t	bytes;
  int		digits;

  digits = 0;
  bytes = 0;
  while (*str && bytes < buflen && digits < 4)
    {
      if (isdigit(*str))
	buf[bytes] = *str;
      else if (*str == ',')
	{
	  if (digits < 3)
	    buf[bytes] = '.';
	  else
	    bytes--;
	  digits++;
	}
      else
	return (-1);
      bytes++;
      str++;
    }
  buf[bytes] = '\0';
  return (read_port_port(str, port));
}

static int	open_data(t_ftp *ftp, char *host, unsigned port)
{
  int		fd;

  close_data(ftp);
  fd = sock_connect(host, port);
  if (fd < 0)
    return (-1);
  ftp->data = xmalloc(sizeof (ftp->data));
  ftp->data->fd = fd;
  return (resp(ftp, 200, "PORT command successful."));
}

int		cmd_port(t_cmd *cmd)
{
  t_ftp		*ftp;
  unsigned	port;
  char		buf[sizeof ("255,255,255,255:65536")];

  ftp = cmd->cm_ftp;
  port = 0;
  if (read_port(cmd->cm_argv[1], buf, sizeof (buf), &port))
    {
      resp(ftp, 501, "Illegal PORT command.");
      return (-1);
    }
  T(ftp, "Openning data connection on %s:%d\n", buf, port);
  return (open_data(ftp, buf, port));
}
