/*
** cmd_rnto.c for ftpserver in /home/chary_c/Prog/my_ftp/server
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Jan  7 21:17:31 2008 corentin chary
** Last update Tue Jan  8 18:01:57 2008 corentin chary
*/

#include <unistd.h>
#include <errno.h>
#include <stdio.h>

#include "error.h"
#include "xalloc.h"
#include "server.h"
#include "cmds.h"

int		cmd_rnto(t_cmd *cmd)
{
  t_ftp		*ftp;

  ftp = cmd->cm_ftp;
  if(!ftp->rnfr)
    {
      resp(ftp, 503, "RNFR required first.");
      return (-1);
    }
  if (rename(cmd->cm_argv[1], ftp->rnfr))
    {
      perr(errno, "rename(%s, %s)", cmd->cm_argv[1], ftp->rnfr);
      resp(ftp, 550, "Rename failed.");
      return (-1);
    }
  resp(ftp, 250, "Rename successful.");
  return (0);
}
