/*
** cmds.h for ftpserver in /home/chary_c/Prog/my_ftp/client
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Fri Jan  4 14:09:41 2008 corentin chary
** Last update Sun Apr 13 19:23:10 2008 corentin chary
*/

#ifndef CMDS_H_
# define CMDS_H_

# include "server.h"

typedef struct s_cmd
{
  t_ftp		*cm_ftp;
  size_t	cm_argc;
  char		**cm_argv;
}		t_cmd;

typedef struct  s_bi_cmd
{
  const char *	bi_name;
  int		(*bi_func)(t_cmd *cmd);
  size_t	bi_args_min;
  size_t	bi_args_max;
  int		bi_data;
}               t_bi_cmd;

int     readcmd(t_cmd *cmd);
int     execcmd(t_cmd *cmd);
void    freecmd(t_cmd *cmd);

int	cmd_quit(t_cmd *cmd);
int	cmd_rest(t_cmd *cmd);
int	cmd_chdr(t_cmd *cmd);
int	cmd_user(t_cmd *cmd);
int	cmd_pass(t_cmd *cmd);
int	cmd_pwd(t_cmd *cmd);
int	cmd_cwd(t_cmd *cmd);
int	cmd_noop(t_cmd *cmd);
int	cmd_rnfr(t_cmd *cmd);
int	cmd_rnto(t_cmd *cmd);
int	cmd_syst(t_cmd *cmd);
int	cmd_type(t_cmd *cmd);
int	cmd_port(t_cmd *cmd);
int	cmd_list(t_cmd *cmd);
int	cmd_nlst(t_cmd *cmd);
int	cmd_rmd(t_cmd *cmd);
int	cmd_mkd(t_cmd *cmd);
int	cmd_dele(t_cmd *cmd);
int	cmd_size(t_cmd *cmd);
int	cmd_retr(t_cmd *cmd);
int	cmd_stor(t_cmd *cmd);
int	cmd_mode(t_cmd *cmd);
int	cmd_stru(t_cmd *cmd);

#endif /* !CMDS_H_ */
