/*
** father.c for ftpserver in /home/chary_c/Prog/my_ftp/server
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Mon Jan  7 13:49:02 2008 corentin chary
** Last update Tue Jan  8 08:32:49 2008 corentin chary
*/

#include <sys/wait.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>

#include "server.h"
#include "sock.h"
#include "error.h"

static void sigchld(int val) {
  (void) val;
  while (waitpid(-1, NULL, WNOHANG) > 0)
    ;
}

static ssize_t	my_read(int fd, void *buf, size_t count)
{
  return (sock_recv(fd, buf, count, -1));
}

static void	ftpset(t_ftp *ftp)
{
  memset(ftp, 0, sizeof (*ftp));
  ftp->timeout = FTP_TIMEOUT;
  ftp->gnlbuf.read = my_read;
  ftp->state = FTP_STATE_LOGIN;
}

static int	loop(int fd, t_ftp *ftp)
{
  pid_t		pid;
  socklen_t	bytes;

  bytes = sizeof (ftp->addr);
  while (1)
    {
      ftp->fd = sock_accept(fd, &ftp->addr, &bytes, 0);
      if (ftp->fd < 0)
	return (ftp->fd);
      pid = fork();
      if (pid < 0)
	err(1, errno, "fork()");
      if (!pid)
	return (child(ftp));
      close(ftp->fd);
      ftp->id++;
    }
}

int		father(short port)
{
  t_ftp		ftp;
  int		fd;
  int		ret;

  signal(SIGCHLD, sigchld);
  ftpset(&ftp);
  fd = sock_listen(port);
  if (fd < 0)
    return (fd);
  ret = loop(fd, &ftp);
  close(fd);
  return (ret);
}
