/*
** server.h for ftpserver in /home/chary_c/Prog/my_ftp/server
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Sat Jan  5 11:21:06 2008 corentin chary
** Last update Sun Apr 13 19:34:00 2008 corentin chary
*/

#ifndef SERVER_H_
# define SERVER_H_

# include <sys/types.h>
# include <sys/socket.h>
# include <limits.h>

# include "gnl.h"

# include "strlcpy.h"
# include "strlcat.h"

# define FTP_BUFSIZE	4096
# define FTP_TIMEOUT	60

# define FTP_STATE_LOGIN	1
# define FTP_STATE_CMD		2
# define FTP_STATE_QUIT		3

# define FTP_TYPE_ASCII		'A'
# define FTP_TYPE_IMAGE		'I'

typedef struct		s_ftp_data
{
  int			fd;
}			t_ftp_data;

typedef struct		s_ftp
{
  int			id;
  int			timeout;
  int			fd;
  char			type;
  int			is_ano;
  char			*user;
  char			home[PATH_MAX];
  char			*rnfr;
  int			offset;
  char			file[PATH_MAX];
  int			state;
  t_ftp_data		*data;
  struct sockaddr	addr;
  t_gnl_buf		gnlbuf;
  size_t		rest;
}			t_ftp;

int	father(short port);
int	child(t_ftp *ftp);
int	resp(t_ftp *ftp, int code, const char *fmt, ...);
int	close_data(t_ftp *ftp);
int	login(t_ftp *ftp, char *password);
int	check_file(t_ftp *ftp, char *dir);
int	check_dir(t_ftp *ftp, char *file);

#define TS(ftp, str)				\
  T(ftp, "%s\n", str);

#define T(ftp, fmt, ...)			\
  do						\
    {						\
      printf("Client %d\t", ftp->id);		\
      printf(fmt, ##__VA_ARGS__);		\
    } while (0)

#endif /* !SERVER_H_ */
